// BEGIN Portals Script

var rippleStatus = 0;
var vidIsPlaying = false;
var playlistStatus = 1;
var eqTop = 0, eqLeft = 0;
var showPlEQVid = false;

function toggleRipple() {
	rippleStatus++;

	switch (rippleStatus) {
		case 1:
			ripple_button.visible	= true;
			vis.visible		= false;
			visbuttons.visible	= false;
		break;


		case 2:
			ripple_button.visible	= false;
			vis.visible		= true;
			visbuttons.visible	= true;
		break;


		case 3:
			ripple_button.visible	= false;
			vis.visible		= false;
			visbuttons.visible	= false;
			rippleStatus		= 0;
		break;
	}
}

function init() {
	loadPrefs();

	volume_slider.value = player.settings.volume;

	playlist_frame.setColumnResizeMode( 1, "AutoSizeData" );
	playlist_frame.setColumnResizeMode( 0, "Stretches" );

	updateMetadata();

	vidIsPlaying = (player.OpenState == osMediaOpen) && (player.currentMedia.ImageSourceWidth>0);
	vidIsPlaying ? startVideo() : endVideo();

	if (!player.controls.isAvailable("Stop")) {
		endVideo();
	}
}

function shutdown() {
	savePrefs();
}

function onPlayStateChange() {
	vidIsPlaying = (player.OpenState == osMediaOpen) && (player.currentMedia.ImageSourceWidth>0);
	vidIsPlaying ? startVideo() : endVideo();

	if (!player.controls.isAvailable("Stop")) {
		endVideo();
	}

	updateMetadata();
}

function startVideo() {
	vidIsPlaying = true;
	showPlEQVid = true;
	detPlaylistEqVideo();
	playlistStatus = 3;
	switchPlEqVid();
}

function endVideo() {
	vidIsPlaying = false;
	playlistStatus = (playlistStatus == 2) ? 1 : 2;
	switchPlEqVid();
}

function switchPlEqVid() {
	switch (playlistStatus) {
		case 1:
			playlistStatus = 2;
			vid.visible = false;
			playlist_frame.visible = false;
			equalizer.visible = true;
			break;
		case 2:
			playlistStatus = 3;
			vid.visible = false;
			equalizer.visible = false;
			playlist_frame.visible = true;
			break;
		case 3:
			playlistStatus = 1;
			if (vidIsPlaying) {
				equalizer.visible = false;
				playlist_frame.visible = false;
				vid.visible = true;
			} else {
				switchPlEqVid();
			}
			break;
	}
}

function updateMetadata() {
	metadata.value = player.currentmedia.getiteminfo("#author");

	if (metadata.value == "") {
		metadata.value = player.currentmedia.getiteminfo("author");
	}

	if (metadata.value != "") {
		metadata.value += " - ";
	}

	metadata.value += player.currentmedia.name;
	metadata.scrolling = (metadata.textWidth>metadata.width);
	metadata.value += (metadata.scrolling) ? "          " : "";
}

function repeatClick() {
	if (player.Settings.getMode('loop')) {
		player.Settings.setMode('loop','false');
	} else {
		player.Settings.setMode('loop','true');
	}
}

function shuffleClick() {
	if (player.Settings.getMode('shuffle')) {
		player.Settings.setMode('shuffle','false');
	} else {
		player.Settings.setMode('shuffle','true');
	}
}

function togPlaylistEqVideo() {
	showPlEQVid			= !showPlEQVid;
	playlist_eq_video.visible	= showPlEQVid;
}

function detPlaylistEqVideo() {
	playlist_eq_video.visible	= showPlEQVid;
}

function loadPrefs() {

	var _rippleStatus	= theme.loadPreference('rippleStatus');
	var _playlistStatus	= theme.loadPreference('playlistStatus');
	var _showPlEQVid	= theme.loadPreference('showPlEQVid');

	if (_rippleStatus != '--') {
		if (!((_rippleStatus <= 2) && (_rippleStatus >= 0))) {
			rippleStatus = 0;
		}
	} else {
		rippleStatus = 0;
	}

	if (_playlistStatus != '--') {
		if (_playlistStatus == 3) {
			playlistStatus = 2;
		} else {
			playlistStatus = 1;
		}	
	} else {
		playlistStatus = 1;
	}

	if (_showPlEQVid != '--') {
		showPlEQVid = (_showPlEQVid.toLowerCase() == 'true') ? true : false;
	} else {
		showPlEQVid = false;
	}

	toggleRipple();
	detPlaylistEqVideo();
	switchPlEqVid();

	vis.currentEffectType = mediacenter.effectType;
	vis.currentPreset = mediacenter.effectPreset;
}

function savePrefs() {
	if (rippleStatus == 0) {
		theme.savePreference('rippleStatus',2);
	} else if (rippleStatus == 1) {
		theme.savePreference('rippleStatus',0);
	} else {
		theme.savePreference('rippleStatus',1);
	}
	theme.savePreference('playlistStatus',playlistStatus);
	theme.savePreference('showPlEQVid',showPlEQVid);

	mediacenter.effectType = vis.currentEffectType;
	mediacenter.effectPreset = vis.currentPreset;
}

// END Portals Script